<?php
//        Script to list the code of a program in Debug mode.
include("debug.inc");

// class debugger

class debugger_ui  extends  debugger_client
{
      var $breakpoints;     // Array of Break Points.
      var $watchpoints;
      var $retval ;

      function debugger_ui($target)
      {
               $this->debugger_client($target);
               $this->retval = "Null";

               $this->watchpoints = serialize(array());
               $this->breakpoints = serialize(array());
      }

      function save($filename)
      {
               $fd = fopen($filename,"w");
               if(!$fd )
                      return FALSE;

               $output = array($this->breakpoints, $this->watchpoints, $this->target);
               $ret = fwrite($fd, serialize($output));

               fclose($fd);
               return TRUE;
      }
      function load($filename)
      {
               $fd = fopen($filename,"r");
               if(!$fd )
                      return FALSE;
               $loaded_values = unserialize( fread($fd, filesize($filename)));
               fclose($fd);

               list( $newbp, $newwp, $newtarget) = $loaded_values;

               $this->breakpoints = $newbp;
               $this->watchpoints = $newwp;
               $this->set_target( $newtarget );

               $bp_array = unserialize($newbp);
               $this->set_bc_array($bp_array) ;

               return TRUE;
      }

      function process_message($command, $argument)        // Overload this function to extend the UI.
      {
               return $this->process_message_base($command, $argument);
      }

      function process_message_base($command, $argument)
      {
             $command = strtoupper($command);
// echo "Processing message (Command=$command, Argument=$argument) <br>";
             if(($command == "B" || $command == "BREAK") && $argument)     //      Add a break point
             {
                        //   Add Break Points ....
                      if( is_numeric($argument) )
                      {
                             if( !$this->target )
                                    return FALSE;
                             $argument = "(_fl()==\"".$this->fl()."\" && _ln()==$argument)" ;
                      }
                      $breakpoints = unserialize($this->breakpoints);
                      array_push($breakpoints, $argument);
                      $this->breakpoints = serialize($breakpoints);
                      //     OK, now lets se the Break Condition in the target ...
                      if( $this->target )
                             $this->set_bc_array($breakpoints);

//                      $new_bc = "";
//                      for($i=0; $i<sizeof($breakpoints); $i++)
//                      {
//                              if($breakpoints[$i])
//                              {
//                                     if( $new_bc )
//                                           $new_bc .= "|| (".$breakpoints[$i]).")";
//                                     else
//                                           $new_bc .= "(".$breakpoints[$i].")";
//                              }
//                      }
//                      $this->set_bc($new_bc);
             }
             else if(($command == "BD" || $command == "DB") && is_numeric($argument) )
             {
                        $breakpoints = unserialize($this->breakpoints);
                        $argument = (int) $argument;
                        if( $argument < sizeof($breakpoints) && $argument >= 0 )
                                $breakpoints[$argument] = "";
                        $this->breakpoints = serialize($breakpoints);
                        if( $this->target )
                                $this->set_bc_array($breakpoints);
             }

             else if($command == "W" || $command == "WATCH")   //      Add a watch point
             {
                        $watchpoints = unserialize($this->watchpoints);
//                      reset($this->watchpoints);
//                      while( list($break_condition, $key) = each($this->watchpoints ) )
//                      {
//                             if( $break_condition == "" )
//                             {
//                                    $this->watchpoints[$key] = $argument;
//                                    return ;
//                             }
//                     }
//                      array_push($this->breakpoints, $argument);
                       array_push($watchpoints, $argument);
                       $this->watchpoints=serialize($watchpoints);
             }
             else if(($command == "WD" || $command == "DW") && is_numeric($argument) )
             {
                        $watchpoints = unserialize($this->watchpoints);
                        $argument = (int) $argument;
                        if( $argument < sizeof($watchpoints) && $argument >= 0 )
                                $watchpoints[$argument] = "";
                        $this->watchpoints = serialize($watchpoints);
             }
             else if($command == "G" || $command == "GO")
             {
                      $this->go($argument);
                      if( !$argument )
                             return FALSE;
             }
             else if($command == "S" || $command == "STEP")
                      $this->step_over($argument);
             else if($command == "SO" )
                      $this->step_out($argument);
             else if($command == "SI" )
             {
                      $this->set_bc_array(serialize($this->breakpoints)) ;
                      if( $argument )
                            $this->step($argument);
                      else
                            $this->step();
             }
             else if($command == "KILL" || $command == "ABORT")
             {
                      $this->terminate_host();
                      return FALSE;
             }
             else if($command == "EXEC" && $this->target)
             {
                      $this->exec($argument, $this->retval);
             }
             else if($command == "DEBUG" && $argument )
             {
//                      $tmp = new pipes($argument);

//                      if( !file_exists($tmp->full_filename() ) )
//                             return FALSE;
//                      $this->set_target($argument);
                      $this->debugger_ui($argument);
                      return FALSE;
             }
             else if($command == "RESET" )
             {
                      $this->watchpoints = serialize(array());
                      $this->breakpoints = serialize(array());
                      $this->break_condition = "";
                      if( $this->target )
                              $this->set_bc("");
//                      while( sizeof($this->breakpoints) )
//                             array__shift($this->breakpoints);
//                      while( sizeof($this->breakpoints) )
//                             array__shift($this->breakpoints);
             }
             else if($command == "HELP" )
                    return FALSE;
             return TRUE;
       }

       function set_bc_array($break_array)
       {
              if( !is_array($break_array) )
                     return FALSE;
              $new_bc = "";
              for($i=0; $i<sizeof($break_array); $i++)
              {
                      if($break_array[$i])
                      {
                             if( $new_bc )
                                   $new_bc .= "|| (".$break_array[$i].")";
                             else
                                   $new_bc .= "(".$break_array[$i].")";
                      }
              }
              if( $new_bc )
              {
                      $new_bc = "(".$new_bc.")";
                      $this->set_bc($new_bc);
              }
              return TRUE;
       }

       function output_watches($isconnected=TRUE)
       {
                $output = "<table width=\"100%\" border=\"0\" cellspacing=\"1\">";
                $watchpoints = unserialize($this->watchpoints);
//              reset($this->watchpoints);
//                for($i=0; $this->watchpoints[$i]; $i++)
//                {
//                        $watches = $this->breakpoints[$i];
//                        $output .= "<tr><td>$i: $watches</td></tr>" ;
//                }
                for($i=0; $i<sizeof($watchpoints); $i++)
                {
                        $watch = $watchpoints[$i];
                        $watch_out = htmlspecialchars($watch);

                        if( $watch )
                        {
                                if( $this->target && $isconnected )
                                      $output .= "<tr><td>$i: $watch_out</td><td>".htmlspecialchars($this->watch($watch))."</td></tr>" ;
                                else
                                      $output .= "<tr><td>$i: $watch_out</td></tr>" ;
                        }
                }
                $output .= "</table>";
                return $output;
       }

       function output_breakpoints($isconnected=TRUE)
       {
                $output = "<table width=\"100%\" border=\"0\" cellspacing=\"1\">" ;
                $breakpoints = unserialize($this->breakpoints);
//                $output .= "<tr><td>Current Condition:".$this->break_condition."</td></tr>";
                for($i=0; $i<sizeof($breakpoints); $i++)
                {
                        $break = $breakpoints[$i];
                        $break_out = htmlspecialchars($break);
                        if( $break )
                        {
                               if( $this->target && $isconnected && $this->watch($break) )
                                      $output .= "<tr><td><b>$i: $break_out</b></td></tr>" ;
                               else
                                      $output .= "<tr><td>$i: $break_out</td></tr>" ;
                        }
                }
//               reset($this->watchpoints);
//               $i=0;
//               while(list($break, $num) = each($this->breakpoints) )
//               {
//                        $i++;
//                        $output .= "<tr><td>$num: $break</td></tr>" ;
//               }

                $output .= "</table>";
                return $output;
       }

       function process_cmd($cmd_line)
       {
                $command = strtok ($cmd_line, " ");
                $argument = substr($cmd_line, strlen($command));

                $command = ltrim(chop($command));
                $argument = stripcslashes(ltrim(chop($argument)));

                return $this->process_message($command, $argument);
       }

}


