<?php

//        Class:                PIPES
//
//        A class to maintain interprocess communication between PHP processes.
//

class pipes
{
        var        $name;
        var        $tmp;

//        ==============
        var         $file_prefix;

        function pipes($new_name)
        {
                $this->name = $new_name;
                $this->file_prefix = get_cfg_var("pipe_location");
                if( !$this->file_prefix )
                        $this->file_prefix = "/tmp/";
        }

        function full_filename($channel=0)
        {
//                return ($this->file_prefix).($this->name);
                return ($this->file_prefix).($this->name).$channel ;
        }

        function send($value, $channel=0)
        {
//echo "\nTrying to send [$value] ....";
                $p = fopen($this->full_filename($channel), "w");
                if( !$p )        return FALSE;

                fwrite($p, serialize($value));
//echo "Value sent() OK.";
                fclose($p);
                return TRUE;
        }

        function receive(&$value, $channel=0)
        {
//echo "\nWaiting to receive ....  ";
                $p = fopen($this->full_filename($channel), "r");
                if( !$p )        return FALSE;

                $buffer = fread($p, 4096);
                if( $buffer )
                        $value = unserialize($buffer);
                fclose($p);
//echo "Value received [$value]";
                return TRUE;
        }

        function exec($command, &$return_val)
        {
                $r = $this->send($command, 1);
                if( $r )
                {
                        $val = "";
                        $r = $this->receive($return_val, 2) ;
                }
                return $r;
        }

        function terminate_host()
        {
                return $this->send("exit();", 1);
        }

        function host()
        {
                $value = "";

                $r = $this->receive($command, 1);
                if( $r )
                {
                        $result = eval($command) ;
                        $r = $this->send($result, 2) ;
                }
                return $r;
        }

//        This function is designed to be eval()'ed, so all locals vars
//        are available to $command.

        function host_str($me)
        {
                return "global \$$me; if(\$$me"."->receive(\$$me"."->tmp,1)) \$$me"."->send(eval(\$$me"."->tmp),2);" ;
        }

        function create_pipes()
        {
                if( function_exists("mkfifo") )
                {
			$r = "";
                        if( !file_exists($this->full_filename()) )
                              $r  = mkfifo($this->full_filename());
                        if( !file_exists($this->full_filename(1)))
                              $r += mkfifo($this->full_filename(1));
                        if( !file_exists($this->full_filename(2)))
                              $r += mkfifo($this->full_filename(2));
                        return $r;
                }
                else
                {
                        system("mkfifo ".$this->full_filename( )." --mode=666") ;
                        system("mkfifo ".$this->full_filename(1)." --mode=666") ;
                        system("mkfifo ".$this->full_filename(2)." --mode=666") ;
                }
        }

        function create_clean_pipes()
        {
                  $this->kill_pipes();
                  $this->create_pipes();
        }

        function kill_pipes()
        {
                if( file_exists($this->full_filename() ))
                    unlink($this->full_filename());
                if( file_exists($this->full_filename(1) ))
                    unlink($this->full_filename(1));
                if( file_exists($this->full_filename(2) ))
                    unlink($this->full_filename(2));
        }

}
